# -*- coding: utf8 -*-
from __future__ import unicode_literals

parser_class = "livecycle"


def test_decode_result(self):
    worklist = self.decode(
        """
    ï»¿Well,Seq no,Sample,Sample id,FAM Std. con.,FAM Cal. con.,FAM Log. con.,FAM Ct,FAM ç»æ,VIC Std. con.,VIC Cal. con.,VIC Log. con.,VIC Ct,VIC ç»æ,Cy5 Std. con.,Cy5 Cal. con.,Cy5 Log. con.,Cy5 Ct,Cy5 ç»æ,Name,Gender,Age,Department,Ward,Bed,Admission number,Diagnosis,Specimen type,Test,Specimen character,Detector,Unit,Inspection applicant,Code,Tester,Auditor,Submission date,Report date,NO
    A01,2020042230010913,,Blanc extraction 1,,,,"26,08",Positive,,,,"25,8",Positive,,,,"32,84",Positive,,,,,,,,,,,,,,,,,,,,
    A02,2020042230020913,,A30005755785,,,,,,,,,,,,,,"22,75",Positive,,,,,,,,,,,,,,,,,,,,
    A03,2020042230030913,,A30005745785,,,,"14,88",Positive,,,,"17,41",Positive,,,,"22,3",Positive,,,,,,,,,,,,,,,,,,,,
    A04,2020042230040913,,A30005730085,,,,,,,,,,,,,,"21,16",Positive,,,,,,,,,,,,,,,,,,,,
    A05,2020042230050913,,A30005751585,,,,"39,17",Positive,,,,,,,,,"21,47",Positive,,,,,,,,,,,,,,,,,,,,
    """
    )
    expected = {
        "context": "result",
        "samples": [
            {
                "rack": "COVID-A01",
                "results": [
                    {"code": "FAM Ct", "value": "26.08"},
                    {"code": "FAM c", "value": "Positive"},
                    {"code": "VIC Ct", "value": "25.8"},
                    {"code": "VIC c", "value": "Positive"},
                    {"code": "Cy5 Ct", "value": "32.84"},
                    {"code": "Cy5 c", "value": "Positive"},
                ],
                "sample_id": "Blanc extraction 1",
                "type": "patient",
            },
            {
                "rack": "COVID-A02",
                "results": [
                    {"code": "Cy5 Ct", "value": "22.75"},
                    {"code": "Cy5 c", "value": "Positive"},
                ],
                "sample_id": "A30005755785",
                "type": "patient",
            },
            {
                "rack": "COVID-A03",
                "results": [
                    {"code": "FAM Ct", "value": "14.88"},
                    {"code": "FAM c", "value": "Positive"},
                    {"code": "VIC Ct", "value": "17.41"},
                    {"code": "VIC c", "value": "Positive"},
                    {"code": "Cy5 Ct", "value": "22.3"},
                    {"code": "Cy5 c", "value": "Positive"},
                ],
                "sample_id": "A30005745785",
                "type": "patient",
            },
            {
                "rack": "COVID-A04",
                "results": [
                    {"code": "Cy5 Ct", "value": "21.16"},
                    {"code": "Cy5 c", "value": "Positive"},
                ],
                "sample_id": "A30005730085",
                "type": "patient",
            },
            {
                "rack": "COVID-A05",
                "results": [
                    {"code": "FAM Ct", "value": "39.17"},
                    {"code": "FAM c", "value": "Positive"},
                    {"code": "Cy5 Ct", "value": "21.47"},
                    {"code": "Cy5 c", "value": "Positive"},
                ],
                "sample_id": "A30005751585",
                "type": "patient",
            },
        ],
    }
    assert worklist == expected
