# -*- coding: utf8 -*-
from __future__ import unicode_literals

import datetime

import driverng

parser_class = "hl7_equsac"


def test_encode_infos(self):
    self.configure(
        hl7_sil_sender_code="MCA",
        hl7_sil_sender_label="Onelink",
        hl7_sil_receiver_code="MIPS",
        hl7_sil_receiver_label="Glims SIL",
    )
    worklist = driverng.Worklist(
        context="info",
        samples=[
            {
                "sample_id": "441010930090",
                "rack": "100XYZ-01-13",
                "type": "patient",
                "orders": [{"code": "CKIN", "action": "add"}],
                "results": [
                    {
                        "code": "TRACKING",
                        "value": "CKIN",
                        "flags": ["42"],
                        "comments": ["0"],
                        "date": datetime.datetime(2021, 10, 30, 16, 8, 23),
                        "instrument": "DMS_RIM-2",
                        "date_plateau": datetime.datetime(2021, 10, 30, 16, 8, 23),
                    }
                ],
            },
            {
                "sample_id": "441010991190",
                "rack": "100XYZ-01-14",
                "type": "patient",
                "orders": [{"code": "CKIN", "action": "add"}],
                "results": [
                    {
                        "code": "TRACKING",
                        "value": "CKIN",
                        "flags": ["42"],
                        "comments": ["0"],
                        "date": datetime.datetime(2021, 10, 30, 16, 8, 23),
                        "instrument": "DMS_RIM-3",
                        "date_plateau": datetime.datetime(2021, 10, 30, 16, 8, 23),
                    }
                ],
            },
        ],
    )
    message = self.encode(
        worklist,
        context={
            "control_id": "1535528471269",
            "now": datetime.datetime(2021, 10, 19, 16, 1, 1),
        },
    )
    assert (
        message
        == """
        MSH|^~\\&|MCA^Onelink||MIPS^Glims SIL||20211019160101||SSU^U03^SSU_U03|1535528471269||2.5.1|||AL|NE||UNICODE UTF-8
        EQU|DMS_RIM-2|20211030160823|OP
        SAC|||441010930090|||||||100XYZ-01|13
        EQU|DMS_RIM-3|20211030160823|OP
        SAC|||441010991190|||||||100XYZ-01|14"""
    )
