# -*- coding: utf8 -*-

from __future__ import unicode_literals

from driverng.tests import BaseTest


class TestPrococolAdvia(BaseTest):
    PROTOCOL_CLASS = "advia2120"
    PROTOCOL_KWARGS = {"mode_query": False, "testing": True}

    @staticmethod
    def unindent(data):
        return data

    def test_send(self):
        self.assertSendMessageEqual(
            """Y     320103316878                           1473678          REBOUL FABIO                    4/14/1999 M 03/31/14 1336        LENV   <cr><lf>007            009            999            002            050            052            003            004            006            001            005            008            051            300            """,
            """
            send <stx>0Y     320103316878                           1473678          REBOUL FABIO                    4/14/1999 M 03/31/14 1336        LENV   <cr><lf>007            009            999            002            050            052            003            004            006            001            005            008            051            300            <cr><lf>F<etx>
            recv 0
            recv <stx>1E        10<cr><lf>r<etx>
            send 1
            """,
        )

    def test_recv(self):
        self.assertRecvMessageEqual(
            """
            recv <stx>0R 320103316878                    03/31/14 19:28:49   <cr><lf> 52 8.33  WB   1 8.33  WB  28    0  WB   2 4.94  WB   3 14.4  WB   5 84.2  WB   4 41.6  WB   6 29.2  WB   7 34.7  WB  51 34.5  WB  10  225  WB  11 10.3  WB  20 64.5  WB  23  2.9  WB  24  0.9  WB  21 25.1  WB  22  5.2  WB  25  1.5  WB  14 5.37  WB  17 0.24  WB  18 0.08  WB  15 2.09  WB  16 0.43  WB  19 0.13  WB  50 8.47  WB 650 70.4  WB 908  0.8  WB  31  0.4  WB 300  2.1  WB   8 13.6  WB   9 2.58  WB  27 -6.9  WB  26 2.06  WB 999 14.3  WB 19158.43  WB 19276.26  WB 311 14.4  WB 312 14.5  WB  29    0  WB  66 22.3  WB 651 27.9  WB  12 53.4  WB 250  441  WB <cr><lf>~<etx>
            send 0
            send <stx>1Z                  0<cr><lf> <etx>
            recv 1
            """,
            """R 320103316878                    03/31/14 19:28:49   \r\n 52 8.33  WB   1 8.33  WB  28    0  WB   2 4.94  WB   3 14.4  WB   5 84.2  WB   4 41.6  WB   6 29.2  WB   7 34.7  WB  51 34.5  WB  10  225  WB  11 10.3  WB  20 64.5  WB  23  2.9  WB  24  0.9  WB  21 25.1  WB  22  5.2  WB  25  1.5  WB  14 5.37  WB  17 0.24  WB  18 0.08  WB  15 2.09  WB  16 0.43  WB  19 0.13  WB  50 8.47  WB 650 70.4  WB 908  0.8  WB  31  0.4  WB 300  2.1  WB   8 13.6  WB   9 2.58  WB  27 -6.9  WB  26 2.06  WB 999 14.3  WB 19158.43  WB 19276.26  WB 311 14.4  WB 312 14.5  WB  29    0  WB  66 22.3  WB 651 27.9  WB  12 53.4  WB 250  441  WB """,
        )
